Index: doc/papers/concurrency/figures/FullCoroutinePhases.fig
===================================================================
--- doc/papers/concurrency/figures/FullCoroutinePhases.fig	(revision bd121597f5a2848db7b765b78bde943061838216)
+++ doc/papers/concurrency/figures/FullCoroutinePhases.fig	(revision 930b504f76f90ec4143311dcab5f540cd4d27d87)
@@ -8,10 +8,11 @@
 -2
 1200 2
-5 1 0 1 0 7 100 0 -1 0.000 0 0 1 0 4575.000 2437.500 4275 1875 4575 1800 4875 1875
+5 1 0 1 0 7 100 0 -1 0.000 0 0 1 0 5175.000 2437.500 4875 1875 5175 1800 5475 1875
 	1 1 1.00 45.00 90.00
-5 1 0 1 0 7 100 0 -1 0.000 0 0 1 0 4575.000 1537.500 4875 2100 4575 2175 4275 2100
+5 1 0 1 0 7 100 0 -1 0.000 0 0 1 0 5175.000 1537.500 5475 2100 5175 2175 4875 2100
 	1 1 1.00 45.00 90.00
-5 1 0 1 0 7 50 -1 -1 0.000 0 1 1 0 4207.500 1642.500 4125 1425 3975 1650 4200 1875
+5 1 0 1 0 7 50 -1 -1 0.000 0 1 1 0 4807.500 1642.500 4725 1425 4575 1650 4800 1875
 	1 1 1.00 45.00 90.00
+6 1575 1575 2700 2025
 2 1 0 1 0 7 100 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
@@ -20,20 +21,25 @@
 	1 1 1.00 45.00 90.00
 	 2175 1575 2400 1800
+4 1 0 100 0 4 10 0.0000 2 165 300 1725 1950 ping\001
+4 1 0 100 0 4 10 0.0000 2 135 360 2475 1950 pong\001
+-6
+6 3075 1575 4200 2025
+6 3075 1575 4200 2025
 2 1 0 1 0 7 100 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 3300 1575 3300 1800
+	 3525 1575 3300 1800
 2 1 0 1 0 7 100 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 3300 2025 3300 2250
-4 1 0 100 0 0 10 0.0000 2 105 555 2100 1200 creation\001
-4 1 0 100 0 4 10 0.0000 2 165 300 1725 1950 ping\001
-4 1 0 100 0 4 10 0.0000 2 135 360 2475 1950 pong\001
-4 1 0 100 0 4 10 0.0000 2 165 300 3300 1950 ping\001
-4 1 0 100 0 4 10 0.0000 2 135 360 3300 2400 pong\001
-4 1 0 100 0 0 10 0.0000 2 105 675 4575 1200 execution\001
-4 1 0 100 0 4 10 0.0000 2 165 300 4275 2025 ping\001
-4 1 0 100 0 4 10 0.0000 2 135 360 4875 2025 pong\001
-4 1 0 100 0 0 10 0.0000 2 90 420 3300 1200 starter\001
+	 3675 1575 3900 1800
+4 1 0 100 0 4 10 0.0000 2 165 300 3225 1950 ping\001
+4 1 0 100 0 4 10 0.0000 2 135 360 3975 1950 pong\001
+-6
+-6
 4 1 0 100 0 4 10 0.0000 2 165 705 2100 1500 pgm main\001
-4 1 0 100 0 4 10 0.0000 2 165 705 3300 1500 pgm main\001
-4 1 0 100 0 4 10 0.0000 2 165 705 4500 1500 pgm main\001
+4 1 0 100 0 4 10 0.0000 2 165 705 3600 1500 pgm main\001
+4 1 0 100 0 4 10 0.0000 2 165 300 4875 2025 ping\001
+4 1 0 100 0 4 10 0.0000 2 135 360 5475 2025 pong\001
+4 1 0 100 0 4 10 0.0000 2 165 705 5100 1500 pgm main\001
+4 1 0 100 0 2 10 0.0000 2 105 540 2100 1275 creator\001
+4 1 0 100 0 2 10 0.0000 2 105 495 3600 1275 starter\001
+4 1 0 100 0 2 10 0.0000 2 105 690 5175 1275 execution\001
Index: doc/papers/concurrency/figures/RunTimeStructure.fig
===================================================================
--- doc/papers/concurrency/figures/RunTimeStructure.fig	(revision bd121597f5a2848db7b765b78bde943061838216)
+++ doc/papers/concurrency/figures/RunTimeStructure.fig	(revision 930b504f76f90ec4143311dcab5f540cd4d27d87)
@@ -36,27 +36,33 @@
 1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4500 3600 15 15 4500 3600 4515 3615
 -6
-6 2175 4650 7050 4950
-1 3 0 1 0 0 0 0 0 0.000 1 0.0000 2250 4830 30 30 2250 4830 2280 4860
-1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4200 4800 150 75 4200 4800 4350 4875
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3275 4800 100 100 3275 4800 3375 4800
+6 3225 4125 4650 4425
+6 4350 4200 4650 4350
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4425 4275 15 15 4425 4275 4440 4290
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4500 4275 15 15 4500 4275 4515 4290
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 4575 4275 15 15 4575 4275 4590 4290
+-6
+1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3450 4275 225 150 3450 4275 3675 4425
+1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4050 4275 225 150 4050 4275 4275 4425
+-6
+6 6675 4125 7500 4425
+6 7200 4200 7500 4350
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 7275 4275 15 15 7275 4275 7290 4290
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 7350 4275 15 15 7350 4275 7365 4290
+1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 7425 4275 15 15 7425 4275 7440 4290
+-6
+1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 6900 4275 225 150 6900 4275 7125 4425
+-6
+6 6675 3525 8025 3975
+2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
+	1 1 1.00 45.00 90.00
+	 6675 3750 6975 3750
+2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
+	1 1 1.00 45.00 90.00
+	 7125 3750 7350 3750
 2 2 0 1 -1 -1 0 0 -1 0.000 0 0 0 0 0 5
-	 5400 4950 5400 4725 5175 4725 5175 4950 5400 4950
-2 2 1 1 -1 -1 0 0 -1 3.000 0 0 0 0 0 5
-	 6525 4950 6300 4950 6300 4725 6525 4725 6525 4950
-4 0 -1 0 0 0 10 0.0000 2 105 450 6600 4875 cluster\001
-4 0 -1 0 0 0 10 0.0000 2 105 660 5475 4875 processor\001
-4 0 -1 0 0 0 10 0.0000 2 105 555 4425 4875 monitor\001
-4 0 -1 0 0 0 10 0.0000 2 120 270 3450 4875 task\001
-4 0 -1 0 0 0 10 0.0000 2 105 660 2325 4875 coroutine\001
--6
-6 3450 1275 3750 1425
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 3525 1350 15 15 3525 1350 3540 1365
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 3600 1350 15 15 3600 1350 3615 1365
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 3675 1350 15 15 3675 1350 3690 1365
--6
-6 5550 1275 5850 1425
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 5625 1350 15 15 5625 1350 5640 1365
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 5700 1350 15 15 5700 1350 5715 1365
-1 3 0 1 -1 -1 0 0 20 0.000 1 0.0000 5775 1350 15 15 5775 1350 5790 1365
+	 7800 3975 7800 3525 7350 3525 7350 3975 7800 3975
+2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
+	1 1 1.00 45.00 90.00
+	 7800 3750 8025 3750
 -6
 1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 5550 2625 150 150 5550 2625 5700 2625
@@ -67,5 +73,4 @@
 1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4425 2850 150 150 4425 2850 4575 2850
 1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4650 2475 150 150 4650 2475 4800 2475
-1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3525 3600 150 150 3525 3600 3675 3600
 1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3975 3600 150 150 3975 3600 4125 3600
 1 3 0 1 0 0 0 0 0 0.000 1 0.0000 3525 3600 30 30 3525 3600 3555 3630
@@ -74,7 +79,9 @@
 1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3975 2850 150 150 3975 2850 4125 2850
 1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 7200 2775 150 150 7200 2775 7350 2775
-1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4650 1350 225 150 4650 1350 4875 1500
-1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 5250 1350 225 150 5250 1350 5475 1500
-1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4050 1350 225 150 4050 1350 4275 1500
+1 3 0 1 0 0 0 0 0 0.000 1 0.0000 2250 4830 30 30 2250 4830 2280 4860
+1 3 0 1 0 0 0 0 0 0.000 1 0.0000 7200 2775 30 30 7200 2775 7230 2805
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3525 3600 150 150 3525 3600 3675 3600
+1 3 0 1 -1 -1 0 0 -1 0.000 1 0.0000 3875 4800 100 100 3875 4800 3975 4800
+1 1 0 1 -1 -1 0 0 -1 0.000 1 0.0000 4650 4800 150 75 4650 4800 4800 4875
 2 2 0 1 -1 -1 0 0 -1 0.000 0 0 0 0 0 5
 	 2400 4200 2400 3750 1950 3750 1950 4200 2400 4200
@@ -140,21 +147,14 @@
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 6675 3975 6975 3975
-2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
-	1 1 1.00 45.00 90.00
 	 7050 2775 6825 2775
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 0 0 2
-	 6825 2775 6825 3975
-2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
-	1 1 1.00 45.00 90.00
-	 7125 3975 7350 3975
-2 2 0 1 -1 -1 0 0 -1 0.000 0 0 0 0 0 5
-	 7800 4200 7800 3750 7350 3750 7350 4200 7800 4200
-2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 2
-	1 1 1.00 45.00 90.00
-	 7800 3975 8025 3975
+	 6825 2775 6825 3750
 2 1 0 1 -1 -1 0 0 -1 0.000 0 0 -1 1 0 4
 	1 1 1.00 45.00 90.00
-	 7875 3975 7875 2325 7200 2325 7200 2550
+	 7875 3750 7875 2325 7200 2325 7200 2550
+2 2 0 1 -1 -1 0 0 -1 0.000 0 0 0 0 0 5
+	 5850 4950 5850 4725 5625 4725 5625 4950 5850 4950
+2 2 1 1 -1 -1 0 0 -1 3.000 0 0 0 0 0 5
+	 6975 4950 6750 4950 6750 4725 6975 4725 6975 4950
 4 1 -1 0 0 0 10 0.0000 2 105 720 5550 4425 Processors\001
 4 1 -1 0 0 0 10 0.0000 2 120 1005 4200 3225 Blocked Tasks\001
@@ -165,2 +165,7 @@
 4 1 -1 0 0 0 10 0.0000 2 105 990 2175 3525 Discrete-event\001
 4 1 -1 0 0 0 10 0.0000 2 135 795 2175 4350 preemption\001
+4 0 -1 0 0 0 10 0.0000 2 150 1290 2325 4875 genrator/coroutine\001
+4 0 -1 0 0 0 10 0.0000 2 120 270 4050 4875 task\001
+4 0 -1 0 0 0 10 0.0000 2 105 450 7050 4875 cluster\001
+4 0 -1 0 0 0 10 0.0000 2 105 660 5925 4875 processor\001
+4 0 -1 0 0 0 10 0.0000 2 105 555 4875 4875 monitor\001