Index: doc/user/user.tex
===================================================================
--- doc/user/user.tex	(revision 08065aa4f1f6324eb9d85876f0a05ba79a3aa20f)
+++ doc/user/user.tex	(revision 1201d54d164b19828cd73f347ace8c9fd400c455)
@@ -11,6 +11,6 @@
 %% Created On       : Wed Apr  6 14:53:29 2016
 %% Last Modified By : Peter A. Buhr
-%% Last Modified On : Tue Jun 25 08:51:33 2019
-%% Update Count     : 3871
+%% Last Modified On : Sat Jul 13 18:36:18 2019
+%% Update Count     : 3876
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
@@ -2697,4 +2697,7 @@
 \subsection{Expressions}
 
+% Change order of expression evaluation.
+% http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2016/p0145r2.pdf
+
 Multiple-return-value functions provide \CFA with a new syntax for expressing a combination of expressions in the return statement and a combination of types in a function signature.
 These notions are generalized to provide \CFA with \newterm{tuple expression}s and \newterm{tuple type}s.
@@ -3506,14 +3509,13 @@
 
 \item
-A separator does not appear before or after a null (empty) C string.
+A separator does not appear before or after a null (empty) C string, which is a local mechanism to disable insertion of the separator character.
 \begin{cfa}
 sout | 1 | "" | 2 | "" | 3;
 123
 \end{cfa}
-which is a local mechanism to disable insertion of the separator character.
 
 \item
 {\lstset{language=CFA,deletedelim=**[is][]{¢}{¢}}
-A seperator does not appear before a C string starting with the (extended) \Index*{ASCII}\index{ASCII!extended} characters: \lstinline[basicstyle=\tt]@,.;!?)]}%¢»@
+A separator does not appear before a C string starting with the (extended) \Index*{ASCII}\index{ASCII!extended} characters: \lstinline[basicstyle=\tt]@,.;!?)]}%¢»@, where \lstinline[basicstyle=\tt]@»@ is a closing citation mark.
 \begin{cfa}[belowskip=0pt]
 sout | 1 | ", x" | 2 | ". x" | 3 | "; x" | 4 | "! x" | 5 | "? x" | 6 | "% x"
@@ -3523,8 +3525,7 @@
 1®,® x 2®.® x 3®;® x 4®!® x 5®?® x 6®%® x 7§\color{red}\textcent§ x 8®»® x 9®)® x 10®]® x 11®}® x
 \end{cfa}}%
-where \lstinline[basicstyle=\tt]@»@ is a closing citation mark.
-
-\item
-A separator does not appear after a C string ending with the (extended) \Index*{ASCII}\index{ASCII!extended} characters: \lstinline[mathescape=off,basicstyle=\tt]@([{=$£¥¡¿«@
+
+\item
+A separator does not appear after a C string ending with the (extended) \Index*{ASCII}\index{ASCII!extended} characters: \lstinline[mathescape=off,basicstyle=\tt]@([{=$£¥¡¿«@, where \lstinline[basicstyle=\tt]@¡¿@ are inverted opening exclamation and question marks, and \lstinline[basicstyle=\tt]@«@ is an opening citation mark.
 %$
 \begin{cfa}[mathescape=off]
@@ -3537,5 +3538,4 @@
 \end{cfa}
 %$
-where \lstinline[basicstyle=\tt]@¡¿@ are inverted opening exclamation and question marks, and \lstinline[basicstyle=\tt]@«@ is an opening citation mark.
 
 \item
@@ -3651,5 +3651,5 @@
 The tuple separator also responses to being turned on and off.
 \begin{cfa}[belowskip=0pt]
-sout | t1 | sepOff | t2; §\C{// locally turn on/off implicit separator}§
+sout | t1 | sepOff | t2; §\C{// turn off implicit separator for the next item}§
 \end{cfa}
 \begin{cfa}[showspaces=true,aboveskip=0pt,belowskip=0pt]
@@ -3675,5 +3675,5 @@
 \subsection{Newline Manipulators}
 
-The following \Index{manipulator} controls \Index{newline separation} for input and output.
+The following \Index{manipulators} control \Index{newline separation} for input and output.
 
 For input:
@@ -3773,5 +3773,6 @@
 
 \item
-\Indexc{nobase}( integer )\index{manipulator!nobase@©nobase©} do not precede ©bin©, ©oct©, ©hex© with ©0b©/©0B©, ©0©, or ©0x©/©0X©. Printing the base is the default.
+\Indexc{nobase}( integer )\index{manipulator!nobase@©nobase©} do not precede ©bin©, ©oct©, ©hex© with ©0b©/©0B©, ©0©, or ©0x©/©0X©.
+Printing the base is the default.
 \begin{cfa}[belowskip=0pt]
 sout | nobase( bin( 27 ) ) | nobase( oct( 27 ) ) | nobase( hex( 27 ) );