Index: tests/io/comp_basic.cfa
===================================================================
--- tests/io/comp_basic.cfa	(revision 123a9f3b0511f0cf549172031f1111b09dc5acda)
+++ tests/io/comp_basic.cfa	(revision 2284d20aa154b6cfdf4a4051fa40e4d6170688bd)
@@ -27,6 +27,6 @@
 
 struct {
-      barrier & bar;
-      int pipe[2];
+	barrier & bar;
+	int pipe[2];
 
 } globals;
@@ -45,29 +45,29 @@
 thread Reader {};
 void main(Reader & this) {
-      bool do_read = has_user_level_blocking( (fptr_t)async_read );
+	bool do_read = has_user_level_blocking( (fptr_t)async_read );
 
-      for(TIMES) {
-            io_future_t f;
-            if ( do_read ) {
-                  char thrash[1];
-                  async_read(f, globals.pipe[0], thrash, 1, 0);
-            } else {
-                  fulfil(f, 0); // If we don't have user-level blocking just play along
-            }
+	for(TIMES) {
+		io_future_t f;
+		if ( do_read ) {
+			char thrash[1];
+			async_read(f, globals.pipe[0], thrash, 1, 0);
+		} else {
+			fulfil(f, 0); // If we don't have user-level blocking just play along
+		}
 
-            block( globals.bar );
+		block( globals.bar );
 
 		yield( prng( this, 15 ) );
 
-            unsigned i = __atomic_add_fetch( &counter, 1, __ATOMIC_SEQ_CST );
+		unsigned i = __atomic_add_fetch( &counter, 1, __ATOMIC_SEQ_CST );
 		if(0 == (i % 100)) sout | i;
 
-            wait( f );
+		wait( f );
 
-            if(f.result < 0)
-                  abort | "Read error" | -f.result | ":" | strerror(-f.result);
+		if(f.result < 0)
+			abort | "Read error" | -f.result | ":" | strerror(-f.result);
 
-            block( globals.bar );
-      }
+		block( globals.bar );
+	}
 }
 
@@ -77,29 +77,29 @@
 thread Writer {};
 void main(Writer & this) {
-      for(TIMES) {
-            block( globals.bar );
+	for(TIMES) {
+		block( globals.bar );
 
-            sleep( 1`us );
+		sleep( 1`us );
 
-            char buf[1] = { '+' };
-            int ret = write( globals.pipe[1], buf, 1 );
-            if(ret < 0)
-                  abort | "Write error" | errno | ":" | strerror(errno);
+		char buf[1] = { '+' };
+		int ret = write( globals.pipe[1], buf, 1 );
+		if(ret < 0)
+			abort | "Write error" | errno | ":" | strerror(errno);
 
-            block( globals.bar );
-      }
+		block( globals.bar );
+	}
 }
 
 int main() {
-      barrier bar = { 2 };
-      &globals.bar = &bar;
-      int ret = pipe(globals.pipe);
-      if(ret != 0)
-            abort | "Pipe error" | errno | ":" | strerror(errno);
+	barrier bar = { 2 };
+	&globals.bar = &bar;
+	int ret = pipe(globals.pipe);
+	if(ret != 0)
+		abort | "Pipe error" | errno | ":" | strerror(errno);
 
      	sout | "starting";
 	{
 		Reader ior;
-            Writer iow;
+		Writer iow;
 	}
 	sout | "done";
Index: tests/io/comp_fair.cfa
===================================================================
--- tests/io/comp_fair.cfa	(revision 123a9f3b0511f0cf549172031f1111b09dc5acda)
+++ tests/io/comp_fair.cfa	(revision 2284d20aa154b6cfdf4a4051fa40e4d6170688bd)
@@ -27,6 +27,6 @@
 
 struct {
-      barrier & bar;
-      int pipe[2];
+	barrier & bar;
+	int pipe[2];
 
 } globals;
@@ -65,29 +65,29 @@
 thread Reader {};
 void main(Reader & this) {
-      bool do_read = has_user_level_blocking( (fptr_t)async_read );
+	bool do_read = has_user_level_blocking( (fptr_t)async_read );
 
-      for(TIMES) {
-            io_future_t f;
-            if ( do_read ) {
-                  char thrash[1];
-                  async_read(f, globals.pipe[0], thrash, 1, 0);
-            } else {
-                  fulfil(f, 0); // If we don't have user-level blocking just play along
-            }
+	for(TIMES) {
+		io_future_t f;
+		if ( do_read ) {
+			char thrash[1];
+			async_read(f, globals.pipe[0], thrash, 1, 0);
+		} else {
+			fulfil(f, 0); // If we don't have user-level blocking just play along
+		}
 
-            block( globals.bar );
+		block( globals.bar );
 
 		yield( prng( this, 15 ) );
 
-            unsigned i = __atomic_add_fetch( &counter, 1, __ATOMIC_SEQ_CST );
+		unsigned i = __atomic_add_fetch( &counter, 1, __ATOMIC_SEQ_CST );
 		if(0 == (i % 100)) sout | i;
 
-            wait( f );
+		wait( f );
 
-            if(f.result < 0)
-                  abort | "Read error" | -f.result | ":" | strerror(-f.result);
+		if(f.result < 0)
+			abort | "Read error" | -f.result | ":" | strerror(-f.result);
 
-            block( globals.bar );
-      }
+		block( globals.bar );
+	}
 }
 
@@ -97,16 +97,16 @@
 thread Writer {};
 void main(Writer & this) {
-      for(TIMES) {
-            block( globals.bar );
+	for(TIMES) {
+		block( globals.bar );
 
-            sleep( 1`us );
+		sleep( 1`us );
 
-            char buf[1] = { '+' };
-            int ret = write( globals.pipe[1], buf, 1 );
-            if(ret < 0)
-                  abort | "Write error" | errno | ":" | strerror(errno);
+		char buf[1] = { '+' };
+		int ret = write( globals.pipe[1], buf, 1 );
+		if(ret < 0)
+			abort | "Write error" | errno | ":" | strerror(errno);
 
-            block( globals.bar );
-      }
+		block( globals.bar );
+	}
 }
 
@@ -122,9 +122,9 @@
 
 int main() {
-      barrier bar = { 2 };
-      &globals.bar = &bar;
-      int ret = pipe(globals.pipe);
-      if(ret != 0)
-            abort | "Pipe error" | errno | ":" | strerror(errno);
+	barrier bar = { 2 };
+	&globals.bar = &bar;
+	int ret = pipe(globals.pipe);
+	if(ret != 0)
+		abort | "Pipe error" | errno | ":" | strerror(errno);
 
      	processor p;
@@ -134,5 +134,5 @@
 		Spinner s;
 		Reader ior;
-            Writer iow;
+		Writer iow;
 	}
 	sout | "done";